// Generated by dts-bundle v0.7.3-fork.1
// Dependencies for this module:
//   ambient.d.ts

declare module '@fullcalendar/resource-common' {
    import '@fullcalendar/resource-common/ambient';
    import '@fullcalendar/resource-common/api/EventApi';
    import '@fullcalendar/resource-common/resource-sources/resource-array';
    import '@fullcalendar/resource-common/resource-sources/resource-func';
    import '@fullcalendar/resource-common/resource-sources/resource-json-feed';
    const _default: import("@fullcalendar/core").PluginDef;
    export default _default;
    export { default as ResourceDayHeader } from '@fullcalendar/resource-common/common/ResourceDayHeader';
    export { VResourceJoiner, AbstractResourceDayTableModel, ResourceDayTableModel, DayResourceTableModel, VResourceSplitter } from '@fullcalendar/resource-common/common/resource-day-table-model';
    export { Resource, ResourceHash, getPublicId } from '@fullcalendar/resource-common/structs/resource';
    export { ResourceViewProps } from '@fullcalendar/resource-common/View';
    export { flattenResources, Group, isGroupsEqual, GroupNode, ResourceNode, buildRowNodes, buildResourceFields } from '@fullcalendar/resource-common/common/resource-hierarchy';
    export { ColSpec, GroupSpec } from '@fullcalendar/resource-common/common/resource-spec';
    export { default as ResourceApi } from '@fullcalendar/resource-common/api/ResourceApi';
    export { default as ResourceSplitter } from '@fullcalendar/resource-common/common/ResourceSplitter';
    export { default as ResourceLabelRoot, ResourceLabelRootProps } from '@fullcalendar/resource-common/common/ResourceLabelRoot';
}

declare module '@fullcalendar/resource-common/ambient' {
    import ResourceApi from '@fullcalendar/resource-common/api/ResourceApi';
    import { ResourceSourceInput, ResourceSource } from '@fullcalendar/resource-common/structs/resource-source';
    import { ResourceHash } from '@fullcalendar/resource-common/structs/resource';
    import { ResourceEntityExpansions } from '@fullcalendar/resource-common/reducers/resourceEntityExpansions';
    import { ResourceAction } from '@fullcalendar/resource-common/reducers/resources';
    module '@fullcalendar/core' {
        interface Calendar {
            addResource(input: ResourceSourceInput): ResourceApi;
            getResourceById(id: string): ResourceApi | null;
            getResources(): ResourceApi[];
            getTopLevelResources(): ResourceApi[];
            refetchResources(): void;
        }
        interface Calendar {
            dispatch(action: ResourceAction): any;
        }
        interface CalendarState {
            resourceSource?: ResourceSource | null;
            resourceStore?: ResourceHash;
            resourceEntityExpansions?: ResourceEntityExpansions;
        }
        interface OptionsInput {
            schedulerLicenseKey?: string;
            resources?: ResourceSourceInput;
            resourceOrder?: any;
            filterResourcesWithEvents?: any;
            resourceGroupField?: any;
            resourceAreaWidth?: any;
            resourceAreaColumns?: any;
            resourcesInitiallyExpanded?: any;
            slotMinWidth?: any;
            datesAboveResources?: any;
            eventResourceEditable?: boolean;
            refetchResourcesOnNavigate?: boolean;
        }
        interface DatePointApi {
            resource?: ResourceApi;
        }
        interface DateSpanApi {
            resource?: ResourceApi;
        }
        interface EventMutation {
            resourceMutation?: {
                matchResourceId: string;
                setResourceId: string;
            };
        }
        interface EventApi {
            getResources: () => ResourceApi[];
            setResources: (resources: (string | ResourceApi)[]) => void;
        }
        interface EventDef {
            resourceIds: string[];
            resourceEditable: boolean;
        }
    }
}

declare module '@fullcalendar/resource-common/api/EventApi' {
    import '@fullcalendar/resource-common/ambient';
}

declare module '@fullcalendar/resource-common/resource-sources/resource-array' {
    export {};
}

declare module '@fullcalendar/resource-common/resource-sources/resource-func' {
    import { ResourceSourceError } from '@fullcalendar/resource-common/structs/resource-source';
    import { ResourceInput } from '@fullcalendar/resource-common/structs/resource';
    export type ResourceFunc = (arg: {
        start: Date;
        end: Date;
        timeZone: string;
    }, successCallback: (events: ResourceInput[]) => void, failureCallback: (errorObj: ResourceSourceError) => void) => any;
}

declare module '@fullcalendar/resource-common/resource-sources/resource-json-feed' {
    export {};
}

declare module '@fullcalendar/resource-common/common/ResourceDayHeader' {
    import { VNode, h, BaseComponent, DateMarker, DateProfile, DateFormatter, ComponentContext, DateRange } from '@fullcalendar/core';
    import { Resource } from '@fullcalendar/resource-common/structs/resource';
    export interface ResourceDayHeaderProps {
        dates: DateMarker[];
        dateProfile: DateProfile;
        datesRepDistinctDays: boolean;
        resources: Resource[];
        renderIntro?: () => VNode;
    }
    export { ResourceDayHeader as default, ResourceDayHeader };
    class ResourceDayHeader extends BaseComponent<ResourceDayHeaderProps> {
        render(props: ResourceDayHeaderProps, state: {}, context: ComponentContext): h.JSX.Element;
        renderResourceRow(resources: Resource[], date: DateMarker): h.JSX.Element;
        renderDayAndResourceRows(dates: DateMarker[], dateFormat: DateFormatter, todayRange: DateRange, resources: Resource[]): h.JSX.Element;
        renderResourceAndDayRows(resources: Resource[], dates: DateMarker[], dateFormat: DateFormatter, todayRange: DateRange): h.JSX.Element;
        renderDateCell(date: DateMarker, dateFormat: DateFormatter, todayRange: DateRange, colSpan: number, resource?: Resource): h.JSX.Element;
        buildTr(cells: VNode[], key: string): h.JSX.Element;
    }
}

declare module '@fullcalendar/resource-common/common/resource-day-table-model' {
    import { Calendar, SlicedProps, EventDef, Splitter, DayTableModel, DayTableCell, SplittableProps, DateSpan, Seg, EventSegUiInteractionState } from '@fullcalendar/core';
    import { Resource } from '@fullcalendar/resource-common/structs/resource';
    export interface ResourceDayTableCell extends DayTableCell {
        resource: Resource;
    }
    export abstract class AbstractResourceDayTableModel {
        dayTableModel: DayTableModel;
        resources: Resource[];
        cells: ResourceDayTableCell[][];
        rowCnt: number;
        colCnt: number;
        resourceIndex: ResourceIndex;
        constructor(dayTableModel: DayTableModel, resources: Resource[], calendar: Calendar);
        abstract computeCol(dateI: any, resourceI: any): number;
        abstract computeColRanges(dateStartI: any, dateEndI: any, resourceI: any): {
            firstCol: number;
            lastCol: number;
            isStart: boolean;
            isEnd: boolean;
        }[];
        buildCells(): ResourceDayTableCell[][];
    }
    export class ResourceDayTableModel extends AbstractResourceDayTableModel {
        computeCol(dateI: any, resourceI: any): any;
        computeColRanges(dateStartI: any, dateEndI: any, resourceI: any): {
            firstCol: any;
            lastCol: any;
            isStart: boolean;
            isEnd: boolean;
        }[];
    }
    export class DayResourceTableModel extends AbstractResourceDayTableModel {
        computeCol(dateI: any, resourceI: any): any;
        computeColRanges(dateStartI: any, dateEndI: any, resourceI: any): any[];
    }
    export class ResourceIndex {
        indicesById: {
            [resourceId: string]: number;
        };
        ids: string[];
        length: number;
        constructor(resources: Resource[]);
    }
    export interface VResourceProps extends SplittableProps {
        resourceDayTableModel: AbstractResourceDayTableModel;
    }
    export class VResourceSplitter extends Splitter<VResourceProps> {
        getKeyInfo(props: VResourceProps): any;
        getKeysForDateSpan(dateSpan: DateSpan): string[];
        getKeysForEventDef(eventDef: EventDef): string[];
    }
    export abstract class VResourceJoiner<SegType extends Seg> {
        joinProps(propSets: {
            [resourceId: string]: SlicedProps<SegType>;
        }, resourceDayTable: AbstractResourceDayTableModel): SlicedProps<SegType>;
        joinSegs(resourceDayTable: AbstractResourceDayTableModel, ...segGroups: SegType[][]): SegType[];
        expandSegs(resourceDayTable: AbstractResourceDayTableModel, segs: SegType[]): any[];
        joinInteractions(resourceDayTable: AbstractResourceDayTableModel, ...interactions: EventSegUiInteractionState[]): EventSegUiInteractionState;
        abstract transformSeg(seg: SegType, resourceDayTable: AbstractResourceDayTableModel, resourceI: number): SegType[];
    }
}

declare module '@fullcalendar/resource-common/structs/resource' {
    import { ConstraintInput, AllowFunc, EventStore, Calendar, EventUi, BusinessHoursInput } from '@fullcalendar/core';
    export interface ResourceInput {
        id?: string;
        parentId?: string;
        children?: ResourceInput[];
        title?: string;
        businessHours?: BusinessHoursInput;
        eventEditable?: boolean;
        eventStartEditable?: boolean;
        eventDurationEditable?: boolean;
        eventConstraint?: ConstraintInput;
        eventOverlap?: boolean;
        eventAllow?: AllowFunc;
        eventClassName?: string[] | string;
        eventClassNames?: string[] | string;
        eventBackgroundColor?: string;
        eventBorderColor?: string;
        eventTextColor?: string;
        eventColor?: string;
        extendedProps?: {
            [extendedProp: string]: any;
        };
        [otherProp: string]: any;
    }
    export interface Resource {
        id: string;
        parentId: string;
        title: string;
        businessHours: EventStore | null;
        ui: EventUi;
        extendedProps: {
            [extendedProp: string]: any;
        };
    }
    export type ResourceHash = {
        [resourceId: string]: Resource;
    };
    export function parseResource(input: ResourceInput, parentId: string, store: ResourceHash, calendar: Calendar): Resource;
    export function getPublicId(id: string): string;
}

declare module '@fullcalendar/resource-common/View' {
    import { Calendar, ViewProps, ViewSpec, ViewPropsTransformer, CalendarComponentProps, EventUi, EventUiHash, EventDefHash, EventDef, EventStore, DateRange } from '@fullcalendar/core';
    import { ResourceHash } from '@fullcalendar/resource-common/structs/resource';
    import { ResourceEntityExpansions } from '@fullcalendar/resource-common/reducers/resourceEntityExpansions';
    export interface ResourceViewProps extends ViewProps {
        resourceStore: ResourceHash;
        resourceEntityExpansions: ResourceEntityExpansions;
    }
    export class ResourceDataAdder implements ViewPropsTransformer {
        filterResources: (resourceStore: ResourceHash, doFilterResourcesWithEvents: boolean, eventStore: EventStore, activeRange: DateRange) => ResourceHash;
        transform(viewProps: ViewProps, viewSpec: ViewSpec, calendarProps: CalendarComponentProps, allOptions: any): {
            resourceStore: ResourceHash;
            resourceEntityExpansions: ResourceEntityExpansions;
        };
    }
    export class ResourceEventConfigAdder implements ViewPropsTransformer {
        buildResourceEventUis: (resourceStore: ResourceHash) => any;
        injectResourceEventUis: (eventUiBases: EventUiHash, eventDefs: EventDefHash, resourceEventUis: EventUiHash) => {
            [key: string]: EventUi;
        };
        transform(viewProps: ViewProps, viewSpec: ViewSpec, calendarProps: CalendarComponentProps): {
            eventUiBases: {
                [key: string]: EventUi;
            };
        };
    }
    export function transformIsDraggable(val: boolean, eventDef: EventDef, eventUi: EventUi, calendar: Calendar): boolean;
}

declare module '@fullcalendar/resource-common/common/resource-hierarchy' {
    import { OrderSpec } from '@fullcalendar/core';
    import { ResourceHash, Resource } from '@fullcalendar/resource-common/structs/resource';
    import { ResourceEntityExpansions } from '@fullcalendar/resource-common/reducers/resourceEntityExpansions';
    import { GroupSpec } from '@fullcalendar/resource-common/common/resource-spec';
    export interface Group {
        value: any;
        spec: GroupSpec;
    }
    export interface GroupNode {
        id: string;
        isExpanded: boolean;
        group: Group;
    }
    export interface ResourceNode {
        id: string;
        rowSpans: number[];
        depth: number;
        isExpanded: boolean;
        hasChildren: boolean;
        resource: Resource;
        resourceFields: any;
    }
    export function flattenResources(resourceStore: ResourceHash, orderSpecs: any): Resource[];
    export function buildRowNodes(resourceStore: ResourceHash, groupSpecs: GroupSpec[], orderSpecs: OrderSpec[], isVGrouping: boolean, expansions: ResourceEntityExpansions, expansionDefault: boolean): (GroupNode | ResourceNode)[];
    export function buildResourceFields(resource: Resource): {
        id: string;
        parentId: string;
        title: string;
        businessHours: import("@fullcalendar/core").EventStore;
        ui: import("@fullcalendar/core").EventUi;
        extendedProps: {
            [extendedProp: string]: any;
        };
        startEditable: boolean;
        durationEditable: boolean;
        constraints: import("@fullcalendar/core").Constraint[];
        overlap: boolean;
        allows: import("@fullcalendar/core").AllowFunc[];
        backgroundColor: string;
        borderColor: string;
        textColor: string;
        classNames: string[];
    };
    export function isGroupsEqual(group0: Group, group1: Group): boolean;
}

declare module '@fullcalendar/resource-common/common/resource-spec' {
    import ResourceApi from '@fullcalendar/resource-common/api/ResourceApi';
    export interface ColSpec {
        group?: boolean;
        isMain?: boolean;
        width?: number;
        field?: string;
        headerClassNames?: (() => string[] | string) | string[] | string;
        headerContent?: (() => any) | any;
        headerDidMount?: (arg: {
            el: HTMLElement;
        }) => void;
        headerWillUnmount?: (arg: {
            el: HTMLElement;
        }) => void;
        cellClassNames?: (arg: {
            resource: ResourceApi;
        }) => string[] | string;
        cellContent?: (arg: {
            resource: ResourceApi;
        }) => any;
        cellDidMount?: (arg: {
            resource: ResourceApi;
            el: HTMLElement;
        }) => void;
        cellWillUnmount?: (arg: {
            resource: ResourceApi;
            el: HTMLElement;
        }) => void;
    }
    export interface GroupSpec {
        field?: string;
        order?: number;
        headerClassNames?: ((groupValue: any) => string[] | string) | string[] | string;
        headerContent?: ((groupValue: any) => any) | any;
        headerDidMount?: (arg: {
            groupValue: any;
            el: HTMLElement;
        }) => void;
        headerWillUnmount?: (arg: {
            groupValue: any;
            el: HTMLElement;
        }) => void;
        laneClassNames?: ((groupValue: any) => string[] | string) | string[] | string;
        laneContent?: ((groupValue: any) => any) | any;
        laneDidMount?: (arg: {
            groupValue: any;
            el: HTMLElement;
        }) => void;
        laneWillUnmount?: (arg: {
            groupValue: any;
            el: HTMLElement;
        }) => void;
    }
}

declare module '@fullcalendar/resource-common/api/ResourceApi' {
    import { Calendar, EventApi } from '@fullcalendar/core';
    import { Resource } from '@fullcalendar/resource-common/structs/resource';
    export { ResourceApi as default, ResourceApi };
    class ResourceApi {
        _calendar: Calendar;
        _resource: Resource;
        constructor(calendar: Calendar, rawResource: Resource);
        setProp(name: string, value: any): void;
        remove(): void;
        getParent(): ResourceApi | null;
        getChildren(): ResourceApi[];
        getEvents(): EventApi[];
        get id(): string;
        get title(): string;
        get eventConstraint(): any;
        get eventOverlap(): any;
        get eventAllow(): any;
        get eventBackgroundColor(): string;
        get eventBorderColor(): string;
        get eventTextColor(): string;
        get eventClassNames(): string[];
        get extendedProps(): any;
    }
}

declare module '@fullcalendar/resource-common/common/ResourceSplitter' {
    import { Splitter, SplittableProps, DateSpan, EventDef } from '@fullcalendar/core';
    import { ResourceHash } from '@fullcalendar/resource-common/structs/resource';
    export interface SplittableResourceProps extends SplittableProps {
        resourceStore: ResourceHash;
    }
    export { ResourceSplitter as default, ResourceSplitter };
    class ResourceSplitter extends Splitter<SplittableResourceProps> {
        getKeyInfo(props: SplittableResourceProps): {
            '': {};
        };
        getKeysForDateSpan(dateSpan: DateSpan): string[];
        getKeysForEventDef(eventDef: EventDef): string[];
    }
}

declare module '@fullcalendar/resource-common/common/ResourceLabelRoot' {
    import { h, Ref, ComponentChildren } from '@fullcalendar/core';
    import { Resource } from '@fullcalendar/resource-common/structs/resource';
    export interface ResourceLabelRootProps {
        resource: Resource;
        date?: Date;
        children: (rootElRef: Ref<HTMLElement>, classNames: string[], dataAttrs: object, innerElRef: Ref<HTMLElement>, innerContent: ComponentChildren) => ComponentChildren;
    }
    export default function ResourceLabelRoot(props: ResourceLabelRootProps): h.JSX.Element;
}

declare module '@fullcalendar/resource-common/structs/resource-source' {
    import { DateRange, Calendar } from '@fullcalendar/core';
    import { ResourceInput } from '@fullcalendar/resource-common/structs/resource';
    import { ResourceFunc } from '@fullcalendar/resource-common/resource-sources/resource-func';
    export type ResourceSourceError = {
        message: string;
        xhr?: XMLHttpRequest;
        [otherProp: string]: any;
    };
    export type ResourceFetcher = (arg: {
        resourceSource: ResourceSource;
        calendar: Calendar;
        range: DateRange | null;
    }, success: (res: {
        rawResources: ResourceInput[];
        xhr?: XMLHttpRequest;
    }) => void, failure: (error: ResourceSourceError) => void) => void;
    export interface ExtendedResourceSourceInput {
        id?: string;
        resources?: ResourceInput[];
        url?: string;
        method?: string;
        extraParams?: object | (() => object);
    }
    export type ResourceSourceInput = ResourceInput[] | ExtendedResourceSourceInput | ResourceFunc | string;
    export interface ResourceSource {
        _raw: any;
        sourceId: string;
        sourceDefId: number;
        meta: any;
        publicId: string;
        isFetching: boolean;
        latestFetchId: string;
        fetchRange: DateRange | null;
    }
    export interface ResourceSourceDef {
        ignoreRange?: boolean;
        parseMeta: (raw: ResourceSourceInput) => object | null;
        fetch: ResourceFetcher;
    }
    export function registerResourceSourceDef(def: ResourceSourceDef): void;
    export function getResourceSourceDef(id: number): ResourceSourceDef;
    export function doesSourceIgnoreRange(source: ResourceSource): boolean;
    export function parseResourceSource(input: ResourceSourceInput): ResourceSource;
}

declare module '@fullcalendar/resource-common/reducers/resourceEntityExpansions' {
    import { ResourceAction } from '@fullcalendar/resource-common/reducers/resources';
    export type ResourceEntityExpansions = {
        [id: string]: boolean;
    };
    export function reduceResourceEntityExpansions(expansions: ResourceEntityExpansions, action: ResourceAction): ResourceEntityExpansions;
}

declare module '@fullcalendar/resource-common/reducers/resources' {
    import { Calendar, CalendarState, Action, DateRange } from '@fullcalendar/core';
    import { ResourceSourceError } from '@fullcalendar/resource-common/structs/resource-source';
    import { ResourceHash, ResourceInput } from '@fullcalendar/resource-common/structs/resource';
    export type ResourceAction = Action | {
        type: 'FETCH_RESOURCE';
    } | {
        type: 'RECEIVE_RESOURCES';
        rawResources: ResourceInput[];
        fetchId: string;
        fetchRange: DateRange | null;
    } | {
        type: 'RECEIVE_RESOURCE_ERROR';
        error: ResourceSourceError;
        fetchId: string;
        fetchRange: DateRange | null;
    } | {
        type: 'ADD_RESOURCE';
        resourceHash: ResourceHash;
    } | // use a hash because needs to accept children
    {
        type: 'REMOVE_RESOURCE';
        resourceId: string;
    } | {
        type: 'SET_RESOURCE_PROP';
        resourceId: string;
        propName: string;
        propValue: any;
    } | {
        type: 'SET_RESOURCE_ENTITY_EXPANDED';
        id: string;
        isExpanded: boolean;
    } | {
        type: 'RESET_RESOURCE_SOURCE';
        resourceSourceInput: any;
    } | {
        type: 'REFETCH_RESOURCES';
    };
    export default function (state: CalendarState, action: ResourceAction, calendar: Calendar): {
        resourceSource: import("@fullcalendar/resource-common/structs/resource-source").ResourceSource;
        resourceStore: ResourceHash;
        resourceEntityExpansions: import("@fullcalendar/resource-common/reducers/resourceEntityExpansions").ResourceEntityExpansions;
        eventSources: import("@fullcalendar/core").EventSourceHash;
        eventSourceLoadingLevel: number;
        loadingLevel: number;
        viewType: string;
        currentDate: Date;
        dateProfile: import("@fullcalendar/core").DateProfile;
        eventStore: import("@fullcalendar/core").EventStore;
        dateSelection: import("@fullcalendar/core").DateSpan;
        eventSelection: string;
        eventDrag: import("@fullcalendar/core").EventInteractionState;
        eventResize: import("@fullcalendar/core").EventInteractionState;
    };
}

